#include <system.h>
#include "bus.h"
#include "../buspins.h"

#ifdef FLIGHT_DATA_RECORDER
	#include "../flash.h"
#endif

#define RECV_SYNC_TIMEOUT	65000

unsigned char recvRecord(struct Record * rec)
{
	uint8_t * data = (uint8_t *)rec;
	
	uint8_t in;
	
	unsigned char byteIndex;
	unsigned char bitIndex;
	unsigned char timeout;
	
	//portc.0 = 1;
	
	/*for (timeout = 0; BUS_SYNC == 0; ++timeout)
	{
		if (timeout > RECV_SYNC_TIMEOUT)
			return false;
			
		delay_10us(1);
	}*/
	/*while (BUS_SYNC == 0)
		;*/
		
	//portc.0 = 0;
	
	for (byteIndex = 0; byteIndex < sizeof(struct Record); ++byteIndex)
	{
		for (bitIndex = 0; bitIndex < 8; ++bitIndex)
		{
			//porta.2 = 0; // clock waveform
			while (BUS_CLOCK == 0)
			{
				if (BUS_SYNC == 0)
					return false;
			}
			
			//portc.0 = BUS_DATA;
			//porta.2 = 1; // clock waveform
				
			in >>= 1;
			in.7 = BUS_DATA;
			
			while (BUS_CLOCK)
			{
				if (BUS_SYNC == 0)
					return false;
			}
		}
		
		data[byteIndex] = in;
	}
	
	// verify checksum
	if (calcChecksum(rec) != rec->checksum)
		return false;
	
	return true;
}

void sendRecord(struct Record * rec, unsigned char clockFlash)
{
	// raise bus sync line to indicate we're about to send a packet
	BUS_SYNC = 1;
	BUS_CLOCK = 0;
	delay_ms(1); // wait a little bit to ensure other chips on the bus are listening
	
	rec->checksum = calcChecksum(rec); // checksum is calculated here rather than above to give a miniscule amount more time for other chips to sync
	
	uint8_t * data = (uint8_t *)rec;
	
	uint8_t out;
	
	unsigned char byteIndex;
	unsigned char bitIndex;
	
	// send each byte of the record
	for (byteIndex = 0; byteIndex < sizeof(struct Record); ++byteIndex)
	{
		out = data[byteIndex];
		
		// send each bit of the byte (one clock period per iteration)
		for (bitIndex = 0; bitIndex < 8; ++bitIndex)
		{
			BUS_DATA = out.0;
			out >>= 1;
			delay_10us(1);
			#ifdef FLIGHT_DATA_RECORDER
				FLASH_CLOCK = clockFlash ? 1 : 0;
			#endif
			BUS_CLOCK = 1;
			delay_10us(1);
			#ifdef FLIGHT_DATA_RECORDER
				FLASH_CLOCK = 0;
			#endif
			BUS_CLOCK = 0;
			delay_10us(1);
		}
	}
	
	BUS_SYNC = 0; // drop bus sync line to indicate end of packet
}
