#include <system.h>

#pragma DATA _CONFIG, _INTRC_OSC_NOCLKOUT & _CP_OFF & _CPD_OFF & _PWRTE_OFF & _WDT_OFF & _MCLRE_OFF & _BODEN_OFF
#pragma CLOCK_FREQ 4000000

unsigned long time = 0;
unsigned char sec = 0;

void main()
{
	trisio = 0;
	ansel = 0;
	gpio = 0;
	
	cmcon |= 0x7; // turn off comparator
	
	// retrieve ocscal and set it
	asm
	{
		bsf _status, RP0  	; Bank 1
		call 0x3ff 	; Get the cal value
		movwf _osccal 	; Calibrate
		bcf _status, RP0 	; Bank 0
	}
	
	clear_bit(option_reg, T0CS); // TMR0 operates on internal clock
	/*set_bit(option_reg, PSA); // prescaler is not assigned to TMR0
	
	// set prescaler
	clear_bit(option_reg, PS2);
	clear_bit(option_reg, PS1);
	clear_bit(option_reg, PS0);*/
	
	set_bit( intcon, GIE );
	//set_bit(intcon, PEIE);

	set_bit( intcon, T0IE ); //enable TMR0 overflow bit   */ 
	
	gpio.1 = 1; // start with charging turned on
	
	//int i = 0;
	
	while (1)
	{
		/*for (i = 0; i < 0xF; ++i)
		{
			gpio = i;
			delay_s(1);
		}*/
		/*gpio.1 = 0;
		delay_s(5);
		gpio.1 = 1;
		delay_s(30);*/
		delay_s(1);
	}
	
}

void interrupt( void )
{
	++time;
	if (time == 3906) // one second at 4MHz
	{
		++sec;
		
		gpio.4 ^= 1;
		
		if (sec == 59)
		{
			gpio.1 = 0; // turn off power
			gpio.2 = 1; // turn on triac
		}
		else if (sec == 60)
		{
			
			gpio.2 = 0; // turn off triac
			gpio.1 = 1; // turn on power
			sec = 0;
		}
		
		time = 0;
	}
	
	clear_bit(intcon, T0IF);  //clear TMR0 overflow flag
	//set_bit(intcon, T0IE);
}

